package com.supervision.ai.service.hub.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.supervision.ai.service.hub.aop.AuditLogDTO;
import com.supervision.ai.service.hub.dto.common.R;
import com.supervision.ai.service.hub.service.AuditLogService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 审计日志管理
 */
@RestController
@RequestMapping("/auditLog")
@RequiredArgsConstructor
public class AuditLogController {

     private final AuditLogService auditLogService;

    /**
     * 分页查询审计日志
     * @param recordType
     * @param userId
     * @param appName
     * @param ip
     * @param page
     * @param pageSize
     * @return
     */
     @RequestMapping("/pageList")
    public R<IPage<AuditLogDTO>> pageList(@RequestParam("recordType") String recordType,
                                          @RequestParam("userId") String userId,
                                          @RequestParam("appName") String appName,
                                          @RequestParam("ip") String ip,
                                          @RequestParam (name = "page", required = false,defaultValue = "1") Integer page,
                                          @RequestParam (name = "pageSize", required = false,defaultValue = "10") Integer pageSize) {
         AuditLogDTO auditLogDTO = new AuditLogDTO(recordType,userId,appName,ip);
         IPage<AuditLogDTO> list = auditLogService.pageList(auditLogDTO,page,pageSize);
        return R.ok(list);
    }


    /**
     * 跟据id查询审计日志
     * @param id
     * @return
     */
    @RequestMapping("/queryById")
    public R<AuditLogDTO> queryById(@RequestParam(name="id") String id) {
        AuditLogDTO auditLogDTO = auditLogService.queryById(id);
        return R.ok(auditLogDTO);
    }
}
