package com.supervision.ai.service.hub.controller;

import cn.hutool.core.lang.Assert;
import cn.hutool.core.util.StrUtil;
import com.supervision.ai.service.hub.dto.common.R;
import com.supervision.ai.service.hub.service.impl.AuthService;
import com.supervision.ai.service.hub.vo.LoginReqVo;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;
import java.util.List;

@RestController
@RequestMapping("/auth")
@RequiredArgsConstructor
public class AuthController {

    private final AuthService authService;

    @PostMapping("/login")
    public R<String> login(@RequestBody LoginReqVo loginReqVo) {
        Assert.notEmpty(List.of(loginReqVo.getUsername(), loginReqVo.getAppName()), "appName和userName不能同时为空");
        String name = StrUtil.isNotEmpty(loginReqVo.getAppName()) ? loginReqVo.getAppName() : loginReqVo.getUsername();
        String token = authService.login(name, loginReqVo.getPassword());
        return R.ok(token);
    }
}
