package com.supervision.ai.service.hub.domain;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import lombok.Data;

/**
 * 
 * @TableName comfyui_prompt
 */
@TableName(value ="comfyui_prompt")
@Data
public class ComfyuiPrompt implements Serializable {
    /**
     * 主键
     */
    @TableId
    private String id;

    /**
     * 提示词名
     */
    private String promptName;

    /**
     * 提示词类型 0:文生图 1：图生图 2：图生视频
     */
    private String promptType;

    /**
     * 提示词
     */
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private JSONObject prompt;


    /**
     * 提示词图片id
     */
    private String iconFileId;

    /**
     * 创建人id
     */
    private String createUserId;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    /**
     * 更新人id
     */
    private String updateUserId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}