package com.supervision.ai.service.hub.domain;

import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.time.LocalDateTime;
import lombok.Data;

/**
 * comfyui提示词参数表
 * @TableName comfyui_prompt_param
 */
@TableName(value ="comfyui_prompt_param")
@Data
public class ComfyuiPromptParam implements Serializable {
    /**
     * 
     */
    @TableId
    private String id;

    /**
     * 提示词id
     */
    private String promptId;

    /**
     * 参数key
     */
    private String paramKey;

    /**
     * 参数json路径，用户后端设置模板中的值
     */
    private String paramPath;

    /**
     * 参数类型 0：整数 1：浮点型 2：字符串 3：布尔值
     */
    private Integer paramType;

    /**
     * 组件类型，用于前端展示
     */
    private String componentType;

    /**
     * 标签，用于前端展示
     */
    private String label;

    /**
     * 是否必填
     */
    private Boolean required;

    /**
     * 默认值，用于前端展示
     */
    private String defaultValue;

    /**
     * 创建人id
     */
    private String createUserId;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    /**
     * 更新人id
     */
    private String updateUserId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}