package com.supervision.ai.service.hub.domain;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import lombok.Data;

/**
 * comfyui任务表
 * @TableName comfyui_task
 */
@TableName(value ="comfyui_task")
@Data
public class ComfyuiTask implements Serializable {
    /**
     * 主键
     */
    @TableId
    private String id;

    /**
     * 提示词id
     */
    private String promptId;

    /**
     * 创建人id
     */
    private String userId;

    /**
     * 应用id
     */
    private String appId;

    /**
     * 运行状态 0未开始、1进行中、2成功、3失败
     */
    private String runStatus;

    /**
     * 开始运行时间
     */
    private LocalDateTime runStartTime;

    /**
     * 运行结束时间
     */
    private LocalDateTime runEndTime;

    /**
     * webhook url
     */
    private String webHook;

    private String comfyuiTaskId;

    @TableField(typeHandler = FastjsonTypeHandler.class)
    private JSONObject prompt;

    private String comfyuiServer;

    /**
     * 创建人id
     */
    private String createUserId;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    /**
     * 更新人id
     */
    private String updateUserId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}