package com.supervision.ai.service.hub.domain;

import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.time.LocalDateTime;
import lombok.Data;

/**
 * comfyui任务参数表
 * @TableName comfyui_task_param
 */
@TableName(value ="comfyui_task_param")
@Data
public class ComfyuiTaskParam implements Serializable {
    /**
     * 主键
     */
    @TableId
    private String id;

    /**
     * 提示词id
     */
    private String promptId;

    /**
     * 任务id
     */
    private String taskId;

    /**
     * 参数key
     */
    private String paramKey;

    /**
     * 参数路径
     */
    private String paramPath;

    /**
     * 参数值
     */
    private String value;

    /**
     * 标签
     */
    private String label;

    /**
     * 是否必填
     */
    private Boolean required;

    /**
     * 参数类型
     */
    private String paramType;

    /**
     * 组件类型 1:input 2:select 3:textarea  4. image 5:checkbox 6:radio
     */
    private String componentType;

    /**
     * 创建人id
     */
    private String createUserId;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     *更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    /**
     * 更新人id
     */
    private String updateUserId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}