package com.supervision.ai.service.hub.domain;

import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import lombok.Data;

/**
 * 
 * @TableName sys_app
 */
@TableName(value ="sys_app")
@Data
public class SysApp implements Serializable {
    /**
     * 主键
     */
    private String id;

    /**
     * 应用名
     */
    private String appName;

    /**
     * 密码
     */
    private String password;

    /**
     * 状态 0:禁用 1:启用
     */
    private Integer status;

    /**
     * 权限url集合
     */
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<String> scopes;

    /**
     * 创建人id
     */
    private String createUserId;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    /**
     * 更新人id
     */
    private String updateUserId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}