package com.supervision.ai.service.hub.dto.comfyui;

import lombok.Data;

import java.time.LocalDateTime;
import java.util.concurrent.CopyOnWriteArrayList;

@Data
public class ServerNode {

    private String id;

    private String host;

    private int port;

    /**
     * 失败次数
     */
    private int failureCount;

    /**
     * 正在运行的任务数量
     */
    private int runningTaskCount;

    private LocalDateTime lastSelectedTime;

    /**
     * 正在运行的任务列表
     */
    private CopyOnWriteArrayList<TaskDTO> runningTasks = new CopyOnWriteArrayList<>();
    public ServerNode() {
    }

    public ServerNode(String id, String host, int port, int failureCount) {
        this.id = id;
        this.host = host;
        this.port = port;
        this.failureCount = failureCount;
    }

    public void incrementFailureCount() {
        this.failureCount++;
        this.lastSelectedTime = LocalDateTime.now();
    }

    public void resetFailureCount() {
        this.failureCount = 0;
        this.lastSelectedTime = LocalDateTime.now();
    }

    public void addRunningTask(TaskDTO task) {
        this.runningTasks.add(task);
    }

    public void removeRunningTask(TaskDTO task) {
        this.runningTasks.remove(task);
    }
}
