package com.supervision.ai.service.hub.service;

import com.alibaba.fastjson.JSONObject;
import com.supervision.ai.service.hub.dto.comfyui.ImageUploadDTO;
import com.supervision.ai.service.hub.dto.comfyui.PromptRunDTO;
import com.supervision.ai.service.hub.dto.comfyui.ResourceViewDTO;

import java.util.Map;
import java.util.function.Consumer;

public interface ComfyUIApiService {

    /**
     * 运行prompt
     * @param prompt 提示词
     * @return
     */
    PromptRunDTO runPrompt(JSONObject prompt);

    /**
     * 查询执行历史
     * @param promptId 提示词id，为空时查询全部
     * @return 经过多次测试发现返回结果只有为空或者completed=true的情况
     */
    Map<String,Object> queryHistory(String promptId);


    void asyncQueryHistory(String promptId, Consumer<String> callback);


    ImageUploadDTO uploadImage(byte[] file, String fileName);

    ResourceViewDTO downloadView(String imageId);


}
