package com.supervision.ai.service.hub.service;

import com.supervision.ai.service.hub.domain.ComfyuiPromptParam;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.Map;

/**
* @author Administrator
* @description 针对表【comfyui_prompt_param】的数据库操作Service
* @createDate 2025-03-31 17:49:56
*/
public interface ComfyUIPromptParamService extends IService<ComfyuiPromptParam> {

    /**
     * 参数校验
     * @param params 待校验参数
     * @param promptId 提示id
     * @return true 通过校验 false 未通过校验
     */
    boolean requiredCheck(Map<String,Object> params, String promptId);


    boolean requiredCheck(Map<String,Object> params, List<ComfyuiPromptParam> promptParamList);

    /**
     * 根据promptId查询参数
     * @param promptId 提示词id
     * @return
     */
    List<ComfyuiPromptParam> listByPromptId(String promptId);


    ComfyuiPromptParam selectPromptParam(String paramKey,List<ComfyuiPromptParam> promptParamList);

}
