package com.supervision.ai.service.hub.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.supervision.ai.service.hub.dto.comfyui.ComfyUIPromptDTO;
import com.supervision.ai.service.hub.vo.comfyui.RunPromptReqVo;
import com.supervision.ai.service.hub.vo.comfyui.TaskResultResVo;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.web.multipart.MultipartFile;
import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface ComfyUIService {


    String executeTask(RunPromptReqVo runPromptReqVo);

    IPage<TaskResultResVo> queryHistory(String promptId);

    /**
     * 从返回的结果中判断任务是否完成
     * @param result 任务执行的结果
     * @return
     */
    boolean taskIsCompleted(Map<String, Object> result);

    /**
     * 从返回的结果中获取图片列表
     * @param result 任务执行的结果
     * @return
     */
    List<String> getImageList(Map<String, Object> result);

    String uploadImage(MultipartFile file) throws IOException;

    void downloadView(String imageId, HttpServletResponse response) throws IOException;

    String saveModel(ComfyUIPromptDTO comfyUIPromptDTO);

    Boolean updateModel(ComfyUIPromptDTO comfyUIPromptDTO);

    Boolean deleteModel(ComfyUIPromptDTO comfyUIPromptDTO);

    ComfyUIPromptDTO queryById(String id);

    IPage<ComfyUIPromptDTO> pageList(String promptName, String promptType, Integer page, Integer pageSize);

    TaskResultResVo getTaskById(String taskId);

}
