package com.supervision.ai.service.hub.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.supervision.ai.service.hub.domain.SysApp;
import com.baomidou.mybatisplus.extension.service.IService;
import com.supervision.ai.service.hub.dto.sys.AppDTO;

/**
* @author Administrator
* @description 针对表【sys_app】的数据库操作Service
* @createDate 2025-04-11 15:51:10
*/
public interface SysAppService extends IService<SysApp> {

    /**
     * 根据应用名称查询应用
     * @param appName 应用名称
     * @return SysApp
     */
    SysApp getByAppName(String appName);

    String saveApp(AppDTO appDTO);

    Boolean updateApp(AppDTO appDTO);

    Boolean deleteApp(AppDTO appDTO);

    IPage<AppDTO> pageList(String appName, Integer page, Integer pageSize);

    AppDTO queryById(String id);

}
