package com.supervision.ai.service.hub.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.supervision.ai.service.hub.domain.SysUser;
import com.baomidou.mybatisplus.extension.service.IService;
import com.supervision.ai.service.hub.dto.sys.UserDTO;

/**
* @author Administrator
* @description 针对表【sys_user】的数据库操作Service
* @createDate 2025-04-11 15:51:10
*/
public interface SysUserService extends IService<SysUser> {


    /**
     * 根据用户名查询用户
     * @param username 用户名
     * @return SysUser
     */
    SysUser getByUsername(String username);

    UserDTO queryById(String id);

    String saveUser(UserDTO user);

    Boolean updateUser(UserDTO user);

    Boolean deleteUser(String id);

    IPage<UserDTO> pageList(String userName, Integer page, Integer pageSize);
}
