package com.supervision.ai.service.hub.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.supervision.ai.service.hub.domain.ComfyuiTaskParam;
import com.supervision.ai.service.hub.service.ComfyuiTaskParamService;
import com.supervision.ai.service.hub.mapper.ComfyuiTaskParamMapper;
import org.springframework.stereotype.Service;
import java.util.ArrayList;
import java.util.List;

/**
* @author Administrator
* @description 针对表【comfyui_task_param(comfyui任务参数表)】的数据库操作Service实现
* @createDate 2025-04-11 15:51:10
*/
@Service
public class ComfyuiTaskParamServiceImpl extends ServiceImpl<ComfyuiTaskParamMapper, ComfyuiTaskParam>
    implements ComfyuiTaskParamService{

    @Override
    public List<ComfyuiTaskParam> listByTaskIds(List<String> taskIds) {
        if (CollUtil.isEmpty(taskIds)){
            return new ArrayList<>();
        }
        return this.lambdaQuery()
                .in(ComfyuiTaskParam::getTaskId, taskIds).list();
    }
}




