package com.supervision.ai.service.hub.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.supervision.ai.service.hub.domain.ComfyuiTaskResult;
import com.supervision.ai.service.hub.service.ComfyuiTaskResultService;
import com.supervision.ai.service.hub.mapper.ComfyuiTaskResultMapper;
import org.springframework.stereotype.Service;
import java.util.ArrayList;
import java.util.List;

/**
* @author Administrator
* @description 针对表【comfyui_task_result】的数据库操作Service实现
* @createDate 2025-04-11 15:51:10
*/
@Service
public class ComfyuiTaskResultServiceImpl extends ServiceImpl<ComfyuiTaskResultMapper, ComfyuiTaskResult>
    implements ComfyuiTaskResultService{

    @Override
    public List<ComfyuiTaskResult> listByTaskIds(List<String> taskIds) {
        if (CollUtil.isEmpty(taskIds)){
            return new ArrayList<>();
        }
        return this.lambdaQuery().in(ComfyuiTaskResult::getTaskId, taskIds).list();
    }
}




