package com.supervision.ai.service.hub.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.supervision.ai.service.hub.domain.SysFile;
import com.supervision.ai.service.hub.dto.sys.FileDTO;
import com.supervision.ai.service.hub.service.SysFileService;
import com.supervision.ai.service.hub.mapper.SysFileMapper;
import io.minio.GetObjectArgs;
import io.minio.MinioClient;
import io.minio.errors.*;
import jakarta.servlet.http.HttpServletResponse;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.InputStream;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

/**
* @author Administrator
* @description 针对表【sys_file(系统文件表)】的数据库操作Service实现
* @createDate 2025-04-11 15:51:10
*/
@Slf4j
@Service
@RequiredArgsConstructor
public class SysFileServiceImpl extends ServiceImpl<SysFileMapper, SysFile>
    implements SysFileService{

    private final MinioClient minioClient;

    @Value("${minio.bucketName}")
    private String bucketName;
    @Override
    public String upload(MultipartFile file) {
        return null;
    }

    @Override
    public IPage<FileDTO> pageList(String fileName, String fileType , Integer page, Integer pageSize) {
        return null;
    }

    @Override
    public FileDTO queryById(String id) {
        return null;
    }

    @Override
    public void downLoad(String fileId, HttpServletResponse response) {

    }

    @Override
    public byte[] downloadFile(String fileId) {
        try {
            InputStream inputStream = minioClient.getObject(
                    GetObjectArgs.builder().bucket(bucketName).object(fileId).build());
            return inputStream.readAllBytes();
        } catch (ErrorResponseException | InsufficientDataException | InternalException | InvalidKeyException |
                 InvalidResponseException | IOException | NoSuchAlgorithmException | ServerException |
                 XmlParserException e) {
            throw new RuntimeException(e);
        }
    }
}




