package com.supervision.ai.service.hub;

import cn.hutool.core.io.FileUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.supervision.ai.service.hub.domain.ComfyuiPrompt;
import com.supervision.ai.service.hub.dto.comfyui.ImageUploadDTO;
import com.supervision.ai.service.hub.dto.comfyui.PromptRunDTO;
import com.supervision.ai.service.hub.dto.comfyui.ResourceViewDTO;
import com.supervision.ai.service.hub.service.ComfyUIApiService;
import com.supervision.ai.service.hub.service.ComfyUIPromptService;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Map;

@Slf4j
@SpringBootTest
public class ComfyUIApiServiceTest {

    @Autowired
    private ComfyUIApiService comfyUIApiService;
    @Test
    public void uploadImageTest() {
        byte[] bytes = FileUtil.readBytes("C:\\Users\\Administrator\\Downloads\\Arya.png");
        ImageUploadDTO res = comfyUIApiService.uploadImage(bytes, "图片1");
        log.info(JSONUtil.toJsonStr(res));

    }

    @Test
    public void runPromptTest() throws InterruptedException {
        //String prompt = "{\"prompt\":{\"4\":{\"inputs\":{\"ckpt_name\":\"sd_xl_base_1.0.safetensors\"},\"class_type\":\"CheckpointLoaderSimple\",\"_meta\":{\"title\":\"Load Checkpoint - BASE\"}},\"5\":{\"inputs\":{\"width\":1024,\"height\":1024,\"batch_size\":1},\"class_type\":\"EmptyLatentImage\",\"_meta\":{\"title\":\"空Latent图像\"}},\"6\":{\"inputs\":{\"text\":\"a cat under the snow with blue eyes, covered by snow, cinematic style, medium shot, professional photo, animal\",\"clip\":[\"4\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"7\":{\"inputs\":{\"text\":\"text, watermark\",\"clip\":[\"4\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"10\":{\"inputs\":{\"add_noise\":\"enable\",\"noise_seed\":2025,\"steps\":25,\"cfg\":8,\"sampler_name\":\"euler\",\"scheduler\":\"normal\",\"start_at_step\":0,\"end_at_step\":20,\"return_with_leftover_noise\":\"enable\",\"model\":[\"4\",0],\"positive\":[\"6\",0],\"negative\":[\"7\",0],\"latent_image\":[\"5\",0]},\"class_type\":\"KSamplerAdvanced\",\"_meta\":{\"title\":\"KSampler (Advanced) - BASE\"}},\"11\":{\"inputs\":{\"add_noise\":\"disable\",\"noise_seed\":0,\"steps\":25,\"cfg\":8,\"sampler_name\":\"euler\",\"scheduler\":\"normal\",\"start_at_step\":20,\"end_at_step\":10000,\"return_with_leftover_noise\":\"disable\",\"model\":[\"12\",0],\"positive\":[\"15\",0],\"negative\":[\"16\",0],\"latent_image\":[\"10\",0]},\"class_type\":\"KSamplerAdvanced\",\"_meta\":{\"title\":\"KSampler (Advanced) - REFINER\"}},\"12\":{\"inputs\":{\"ckpt_name\":\"sd_xl_refiner_1.0.safetensors\"},\"class_type\":\"CheckpointLoaderSimple\",\"_meta\":{\"title\":\"Load Checkpoint - REFINER\"}},\"15\":{\"inputs\":{\"text\":\"evening sunset scenery blue sky nature, glass bottle with a galaxy in it\",\"clip\":[\"12\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"16\":{\"inputs\":{\"text\":\"text, watermark\",\"clip\":[\"12\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"17\":{\"inputs\":{\"samples\":[\"11\",0],\"vae\":[\"12\",2]},\"class_type\":\"VAEDecode\",\"_meta\":{\"title\":\"VAE解码\"}},\"19\":{\"inputs\":{\"filename_prefix\":\"ComfyUI\",\"images\":[\"17\",0]},\"class_type\":\"SaveImage\",\"_meta\":{\"title\":\"保存图像\"}}}}";
        String prompt = "{\"prompt\":{\"6\":{\"inputs\":{\"text\":\"A young boy stands calmly in the foreground, looking directly at the camera, as a house fire rages in the background. Flames engulf the structure, with smoke billowing into the air. Firefighters in protective gear rush to the scene, a fire truck labeled '38' visible behind them. The girl's neutral expression contrasts sharply with the chaos of the fire, creating a poignant and emotionally charged scene.\",\"clip\":[\"38\",0]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP Text Encode (Positive Prompt)\"}},\"7\":{\"inputs\":{\"text\":\"worst quality, inconsistent motion, blurry, jittery, distorted\",\"clip\":[\"38\",0]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP Text Encode (Negative Prompt)\"}},\"8\":{\"inputs\":{\"samples\":[\"72\",0],\"vae\":[\"44\",2]},\"class_type\":\"VAEDecode\",\"_meta\":{\"title\":\"VAE解码\"}},\"38\":{\"inputs\":{\"clip_name\":\"t5xxl_fp16.safetensors\",\"type\":\"ltxv\",\"device\":\"default\"},\"class_type\":\"CLIPLoader\",\"_meta\":{\"title\":\"加载CLIP\"}},\"41\":{\"inputs\":{\"filename_prefix\":\"ComfyUI\",\"fps\":24.000000000000004,\"lossless\":false,\"quality\":90,\"method\":\"default\",\"images\":[\"8\",0]},\"class_type\":\"SaveAnimatedWEBP\",\"_meta\":{\"title\":\"保存动画（WEBP）\"}},\"44\":{\"inputs\":{\"ckpt_name\":\"ltx-video-2b-v0.9.safetensors\"},\"class_type\":\"CheckpointLoaderSimple\",\"_meta\":{\"title\":\"Checkpoint加载器（简易）\"}},\"69\":{\"inputs\":{\"frame_rate\":25.000000000000004,\"positive\":[\"77\",0],\"negative\":[\"77\",1]},\"class_type\":\"LTXVConditioning\",\"_meta\":{\"title\":\"LTXV条件\"}},\"71\":{\"inputs\":{\"steps\":50,\"max_shift\":2.0500000000000003,\"base_shift\":0.9500000000000002,\"stretch\":true,\"terminal\":0.10000000000000002,\"latent\":[\"77\",2]},\"class_type\":\"LTXVScheduler\",\"_meta\":{\"title\":\"LTXV调度器\"}},\"72\":{\"inputs\":{\"add_noise\":true,\"noise_seed\":2025,\"cfg\":3,\"model\":[\"44\",0],\"positive\":[\"69\",0],\"negative\":[\"69\",1],\"sampler\":[\"73\",0],\"sigmas\":[\"71\",0],\"latent_image\":[\"77\",2]},\"class_type\":\"SamplerCustom\",\"_meta\":{\"title\":\"自定义采样器\"}},\"73\":{\"inputs\":{\"sampler_name\":\"euler\"},\"class_type\":\"KSamplerSelect\",\"_meta\":{\"title\":\"K采样器选择\"}},\"77\":{\"inputs\":{\"width\":704,\"height\":480,\"length\":161,\"batch_size\":1,\"positive\":[\"6\",0],\"negative\":[\"7\",0],\"vae\":[\"44\",2],\"image\":[\"78\",0]},\"class_type\":\"LTXVImgToVideo\",\"_meta\":{\"title\":\"LTXV图像到视频\"}},\"78\":{\"inputs\":{\"image\":\"8.png\"},\"class_type\":\"LoadImage\",\"_meta\":{\"title\":\"加载图像\"}}}}";
        PromptRunDTO res = comfyUIApiService.runPrompt(JSON.parseObject(prompt));

        log.info("执行工作流成功，res:{}", JSONUtil.toJsonStr(res));
        for (int i = 0; i < 50; i++) {
            String promptId = res.getPrompt_id();
            Map<String, Object> history = comfyUIApiService.queryHistory(promptId);
            log.info("查询任务状态：{}",JSONUtil.toJsonStr(history));
            Thread.sleep(1000 *1);
        }
    }

    @Test
    public void queryHistoryTest() {
        Map<String, Object> res = comfyUIApiService.queryHistory("512f2ad2-2c7b-4227-8e52-86be11c3d5b9");
        log.info(JSONUtil.toJsonStr(res));
    }

    @Test
    public void downloadImageTest() {
        ResourceViewDTO resourceViewDTO = comfyUIApiService.downloadView("ComfyUI_00070_.png");
        FileUtil.writeBytes(resourceViewDTO.getContent(), "C:\\Users\\Administrator\\Downloads\\ComfyUI_00070_.png");
    }

    @Autowired
    private ComfyUIPromptService comfyUIPromptService;

    @Test
    public void test() {
        ComfyuiPrompt comfyuiPrompt = comfyUIPromptService.getById("1");
        System.out.println(comfyuiPrompt);
    }
}
